import type { SpecialCardType } from "./cards"

type PlayerAction = {
	initiatingPlayerId: string
} & (
	| {
		type: "join"
		name: string
	}
	| {
		type: "hit"
	}
	| {
		type: "stay"
	}
	| {
		type: "use-special"
		cardType: SpecialCardType
	}
	| {
		type: "leave"
	}
)

type ServerAction = {
	initiatingPlayerId?: never
} & (
	| {
		type: "start"
		targetSum: number
	}
	| {
		type: "deal-number"
		toPlayerId: string
		number: number
		isCovert: boolean
	}
	| {
		type: "deal-special"
		toPlayerId: string
		cardType: SpecialCardType
	}
	| {
		type: "end"
		winnerIds: string[]
		cardsByPlayerId: Record<string, number[]> // without redactions
	}
)


export type GameAction = {
	index: number
} & (PlayerAction | ServerAction)